Bug 678789 - gpxe virtio-net driver incorrectly hardcodes frame length always as 1514
Summary: gpxe virtio-net driver incorrectly hardcodes frame length always as 1514
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gpxe
Version: 13
Hardware: All
OS: All
unspecified
medium
Target Milestone: ---
Assignee: Matt Domsch
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 679188
TreeView+ depends on / blocked
 
Reported: 2011-02-19 17:21 UTC by Charles R. Anderson
Modified: 2011-03-03 03:40 UTC (History)
5 users (show)

Fixed In Version: gpxe-1.0.1-4.fc15
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 679188 (view as bug list)
Environment:
Last Closed: 2011-03-02 01:51:56 UTC


Attachments (Terms of Use)
virtio-net: set size of transmitted ethernet frame to header + data length (621 bytes, patch)
2011-02-19 17:21 UTC, Charles R. Anderson
no flags Details | Diff

Description Charles R. Anderson 2011-02-19 17:21:22 UTC
Created attachment 479710 [details]
virtio-net: set size of transmitted ethernet frame to header + data length

Description of problem:

All ethernet frames sent by gpxe's virtio-net driver have a length of 1514, regardless of the actual size needed to encapsulate the data.  This messes up at least DHCP on some networks, because the DHCP relay agent can't manipulate the "full" ethernet frame.  This was causing KVM PXE failures for me since the DHCP transaction wouldn't complete.

Version-Release number of selected component (if applicable):
gpxe-1.0.1-1

How reproducible:
always

Steps to Reproduce:
1. Use virt-manager to create a VM with network driver virtio
2. Try to PXE boot the VM
3. Monitor the traffic--all frames have an ethernet length of 1514
  
Actual results:
fail to boot via PXE

Expected results:
Should boot via PXE.  virtio-net should set the ethernet frame length to the actual size of the data to be sent + headers.

Additional info:
See attached patch for the fix.

Comment 1 Charles R. Anderson 2011-02-19 17:29:03 UTC
Same fix needs to be applied to F13, F14, F15, rawhide/F16, and EL5 branches.  Thanks.

Comment 2 Levente Farkas 2011-02-20 20:05:37 UTC
what's up with el6?

Comment 3 Charles R. Anderson 2011-02-21 16:58:13 UTC
Same bug exists in el6.  Could someone who has a RHEL subscription please open a ticket?  Thanks.

Comment 4 Matt Domsch 2011-02-21 20:31:17 UTC
EL6 bug #679188

Thanks for the patch Chuck.  Applied on F13-rawhide and EL5 branches now.  Gonna need some testing.

Comment 5 Fedora Update System 2011-02-21 20:45:25 UTC
gpxe-1.0.1-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/gpxe-1.0.1-3.el5

Comment 6 Fedora Update System 2011-02-21 20:46:10 UTC
gpxe-1.0.1-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/gpxe-1.0.1-3.fc14

Comment 7 Fedora Update System 2011-02-21 20:46:38 UTC
gpxe-1.0.1-3.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/gpxe-1.0.1-3.fc13

Comment 8 Fedora Update System 2011-02-22 04:37:50 UTC
gpxe-1.0.1-4.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/gpxe-1.0.1-4.fc15

Comment 9 Fedora Update System 2011-02-22 04:53:23 UTC
gpxe-1.0.1-3.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update gpxe'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/gpxe-1.0.1-3.fc13

Comment 10 Fedora Update System 2011-03-02 01:51:51 UTC
gpxe-1.0.1-3.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2011-03-02 01:52:28 UTC
gpxe-1.0.1-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2011-03-03 03:39:53 UTC
gpxe-1.0.1-4.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.